;========================= DOSEXT PCX LOADER =================================

;NOSHIFT=1                     ;shift palette (24bit -> 18bit)

;
; Load PCX file. (very fast !)
; In:
;   REGS._BX - Handle of opened .PCX file (with OpenFile).
;   EDI - offset of virtual screen (+palette if needed).
; Out:
;   CF = 0 Image loaded.
;     EAX = BYTES per pixels of image loaded.
;     ECX = Largeur de l'image en pixels (Xres).
;     EDX = Hauteur de l'image en pixels (Yres).
;     ESI = Offset de la palette 18/24 bit (si al=8)
;     >>>> BUFFER DESTROYED !!!! <<<<
;   CF = 1 Error:
;     AL  = 00h -> file not found.
;     AL  = 01h -> unknown PCX format.
;     other registers preserved.
;
Loadpcx  proc near
         Pushad
         Mov edi,bufferbase
         Mov ecx,128
         Call Readfile         ;lit l'en-tte
         Mov byte ptr [esp+28],00h      ;al -> 0
         Jc @@Pcxerr
         Cmp word ptr [edi],050Ah       ;PCX 5 ??
         Mov byte ptr [esp+28],01h
         Jnz @@Pcxerr
         Cmp byte ptr [edi+3],08h       ;8 bit/pixel ?
         Jnz @@Pcxerr
         Cmp byte ptr [edi+65],01h      ;1 plan ?
         Jnz @@Pcxerr
         Movzx eax,word ptr [edi+8]
         Movzx edx,word ptr [edi+10]
         Inc eax
         Inc edx
         Mov [esp+24],eax
         Mov [esp+20],edx
         Imul edx,eax                   ;edx = nbre de points de l'image.

         Mov ebx,edi
         Mov edi,[esp]                  ;rcupre edi sur la pile.
         Cmp byte ptr [ebx+2],0         ;compress ?
         Jz short Nocomp                ;Non -> alors NoComp

         Call Nxt64k
 NxtByte:                               ;PCX COMPRESSE.
         Mov al,[ebx+esi]
         Inc si
         Jnz short Noovf1
         Call Nxt64k
 Noovf1:
         Cmp al,192
         Ja short Comp
         Stosb
         Dec edx
         Jnz short NxtByte
         Jmp Pal

 Comp:   And eax,00111111b
         Mov ecx,eax
         Mov al,[ebx+esi]
         Inc si
         Jnz short Noovf2
         Call Nxt64k
 Noovf2:
         Sub edx,ecx
         Rep Stosb
         Or edx,edx
         Jnz short NxtByte
 Pal:
         Mov [esp+4],edi                ;sauve le dbut de la palette.
         Mov ecx,768
 Nxtpal: Inc si
         Jnz short Noovf4
         Call Nxt64k
 Noovf4: Mov al,[ebx+esi]
IFDEF NOT NOSHIFT
         Shr al,2                       ;shift palette or not.
ENDIF
         Mov [edi],al
         Inc edi
         Dec ecx
         Jnz short Nxtpal

 Finpcx:
         Movzx eax,byte ptr [ebx+65]
         Mov [esp+28],eax
         Clc
         Popad
         Ret

 Nocomp:                                ;PCX NON COMPRESSE.
         Call Nxt64k
         Shr edx,2
 Nxtdw:  Mov eax,[ebx+esi]
         Add si,4
         Jnz short Noovf3
         Call Nxt64k
 Noovf3: Stosd
         Dec edx
         Jnz short Nxtdw
         Jmp short Pal

 Nxt64k: Push edi eax ecx               ;CHARGEMENT DE 64Ko.
         Mov esi,128
         Mov ecx,65536-128
         Lea edi,[ebx+esi]              ;on ecrit aprs l'en-tte.
         Call Readfile
         Pop ecx eax edi
         Ret
 @@Pcxerr:
         Popad                          ;ERREUR.
         Stc
         Ret
Loadpcx  Endp
